chrome.storage.local.get(null , function(storage) {
  const origin = window.location.origin;
  const isMixmaxUrl = origin.startsWith('https://') && origin.endsWith('.mixmax.com');
  const isLinkedInUrl =
    origin.startsWith('https://') &&
    origin.endsWith('.linkedin.com') &&
    window.location.pathname.startsWith('/sales/widget');

  const isUnsupportedIFrame = top !== window && !isMixmaxUrl && !isLinkedInUrl;
  if (isUnsupportedIFrame) return;

  storage.extensionVersion = chrome.runtime.getManifest().version;

  window.MIXMAX_STORAGE = storage;

  if (shouldInjectGlobals()) {
    const globalDefinitions = document.createElement('script');

    globalDefinitions.setAttribute('data-mixmax-globals', '');

    globalDefinitions.innerHTML = 'MIXMAX_STORAGE = ' + JSON.stringify(storage) + ';';

    (document.head || document.documentElement).appendChild(globalDefinitions);
  }
});

const rSidebarAnywhereOrigin = /^https:\/\/extension(?:-[a-z]+)?\.mixmax\.com$/;
const rAppOrigin = /^https:\/\/app(?:-[a-z]+)?\.mixmax\.com$/;
const rEmailAppsOrigin = /^https:\/\/emailapps(?:-[a-z]+)?\.mixmax\.com$/;

const { origin } = window.location,
  isAppOrigin = rAppOrigin.test(origin);

function shouldInjectGlobals() {
  return isAppOrigin || rSidebarAnywhereOrigin.test(origin) || rEmailAppsOrigin.test(origin);
}

if (isAppOrigin && chrome.extension.inIncognitoContext) {
  (document.body || document.documentElement).dataset.mixmaxIsIncognito = true;
}
