let enabledMailtoLinks = false;
const MAIL_REPORT_RUNTIME_ERROR = 0.1;

function setEnabled() {
  chrome.storage.local.get(null , function(storage) {
    enabledMailtoLinks = Object.keys(storage).some(function(key) {
      return /^onboarded_(.+)_[a-z]+$/.test(key) && storage[key];
    });
  });
}

setEnabled();
chrome.storage.onChanged.addListener(setEnabled);

document.documentElement.addEventListener(
  'click',
  function(e) {
    if (!enabledMailtoLinks) return;
    if (e.defaultPrevented) return;

    const link = e.target.closest('a[href^="mailto:"]');
    if (!link) return;

    e.preventDefault();
    e.stopPropagation();
    e.stopImmediatePropagation();

    const href = link.href;

    try {
      chrome.runtime.sendMessage({
        method: 'mailTo',
        payload: {
          href,
        },
      });
    } catch (err) {
      if (/Invocation.+doesn't match/i.test(err.message)) {
        window.location.reload();
      } else {
        if (Math.random() > MAIL_REPORT_RUNTIME_ERROR) return; 
        error.captureException(err, {
          culprit: 'Could not message extension',
          extra: {
            payload: {
              href,
            },
          },
        });
      }
    }
  },
  true 
);
