
let interceptedMethodCallId = null;

const MIXMAX_EXTENSION_ID = chrome.runtime.id;

window.addEventListener(
  'message',
  (e) => {
    if (!e.data) return;

    const { methodName, type, id, result } = e.data;

    if (type === 'METHOD_CALL' && methodName === 'getIncompatibleExtensions') {
      interceptedMethodCallId = id;
      return;
    }

    if (type === 'METHOD_RETURN' && interceptedMethodCallId === id && Array.isArray(result)) {
      const hasMixmaxMentioned = result.some((item) => item.id === MIXMAX_EXTENSION_ID);
      if (!hasMixmaxMentioned) return;

      e.stopImmediatePropagation();
      e.stopPropagation();

      e.data.result = result.filter(({ id }) => id !== MIXMAX_EXTENSION_ID);

      window.postMessage(e.data, '*');

      interceptedMethodCallId = null;
    }
  },
  { capture: true }
);
